//
//  PRImageView.m
//  PRICE
//
//  Created by Riccardo Mottola on Thu Dec 12 2002.
//  Copyright (c) 2002-2003 Carduus. All rights reserved.
//
// This program is free software; you can redistribute it and/or modify it under the terms of the version 2 of the GNU General Public License as published by the Free Software Foundation.
// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

#import "PRImageView.h"


@implementation PRImageView


- (void)drawRect:(NSRect)rect {
//    [self validateScrollers];
    [super drawRect:rect];
}

- (void)scaleFrameBy:(float)scale
{
    NSSize imageSize;
    NSAffineTransform *at;
    
    imageSize = [[self image] size];
    at = [NSAffineTransform transform];
    [at scaleBy:scale];
    
    [self setFrameSize:[at transformSize:imageSize]];
    [self setNeedsDisplay:YES];
}

- (void)validateScrollers
{
    NSScrollView *scrollView;
    NSSize selfSize;
    NSSize sViewSize;
    BOOL hFlag;
    BOOL vFlag;
    
//    scrollView = (NSScrollView*)[[self superview] superview];
    scrollView = [self enclosingScrollView];
    selfSize = [self frame].size;
    sViewSize = [scrollView frame].size;
    hFlag = selfSize.width > sViewSize.width;
    vFlag = selfSize.height > sViewSize.height;
    
    [scrollView setHasHorizontalScroller:hFlag];
    [scrollView setHasVerticalScroller:vFlag];
}

-(void) dealloc
{
    NSLog(@"PRImageView dealloc");
    [super dealloc];
}

@end
